/*
   TimingGame:
   LEDs are illuminated up and down.
   One button stops the game, the oher resumes, and pot adjusts game speed.
   The objective is for the player to stop the LEDs ass close to the top as possible.
*/

//create array for LEDs
const int led[] = {13, 3, 4, 5, 6, 7, 8, 9};

//integers for buttons and pot
const int button1 = 15;
const int button2 = 16;
const int pot = A0;

//integer for pot reading
int potValue = 0;
//integers to track if buttons have been pressed
int pressed1 = 0;
int pressed2 = 0;

void setup() {

  //set LEDs to output
  for (int x = 0; x < 8; x++) {
    pinMode(led[x], OUTPUT);
  }

  //set buttons and pot to input
  pinMode(button1, INPUT);
  pinMode(button2, INPUT);
  pinMode(pot, INPUT);
}

void loop() {

  //LEDs ascending
  for ( int x = 0; x < 8; x++) {

    //turn LED on
    digitalWrite(led[x], HIGH);

    //check pot to adjust speed
    potValue = 160 - (analogRead(pot) / 8);

    //pause to give user a chance to press the button
    for (int count = 0; count < potValue; count++) {

      //check is button1 is being pressed
      pressed1 = digitalRead(button1);

      //if button1 has been pressed
      if (pressed1) {

        //wait until button2 has been pressed to resume
        while (!pressed2) {

          //check if button2 has been pressed
          pressed2 = digitalRead(16);
        }

        //reset button2
        pressed2 = 0;
      }

      //reset button1
      pressed1 = 0;

      //delay for stability
      delay(1);
    }
  }

  //LEDs descending
  for ( int x = 7; x >= 0; x-- ) {

    //turn LED off
    digitalWrite(led[x], LOW);

    //check pot to adjust speed
    potValue = 160 - (analogRead(pot) / 8);

    //pause to give user a chance to press the button
    for (int count = 0; count < potValue; count++) {

      //check is button1 is being pressed
      pressed1 = digitalRead(button1);

      //if button1 has been pressed
      if (pressed1) {

        //wait until button2 has been pressed to resume
        while (!pressed2) {

          //check if button2 has been pressed
          pressed2 = digitalRead(16);
        }

        //reset button2
        pressed2 = 0;
      }

      //reset button1
      pressed1 = 0;

      //delay for stability
      delay(1);
    }
  }
}
