
/*
   RandomReaction:
   Turn on random LEDs one at a time, for a random period of time. The objective is to stop the top LED when it is illuminated. 
*/

//integer for random delay time when speaker is ON
int onTime = 0;
//integer for random LED
int ledChoice = 0;

//integer for button
int button = 15;
//integer to check if button has been pressed
int pressed = 0;

//create array of integers for LEDs
const int led[] = { 13, 3, 4, 5, 6, 7, 8, 9 };

void setup() {

  //set all LEDs to output
  for (int x = 0; x < 8; x++) {
    //use array index to refer to each LED
    pinMode(led[x], OUTPUT);
  }

  //set button to input
  pinMode(button, INPUT);
}

void loop() {

  //Choose random LED (0 - 7)
  ledChoice = random(8);
  //assign random number for delay up to 400ms (ON)
  onTime = random(100, 600);

  //turn LED on for onTime
  digitalWrite(led[ledChoice], HIGH);

  waitTime(ledChoice, onTime);

  //turn LED off
  digitalWrite(led[ledChoice], LOW);
}

//function to replace delay and check for button1
void waitTime(int choice, int wait) {

  //pause to give user a chance to press the button
  for (int count = 0; count < wait; count++) {

    //check is button1 is being pressed
    pressed = digitalRead(button);

    //if button has been pressed
    if (pressed) {

      //if user wins, call on win function
      if (choice == 7) {
        win();
        //reset button
        pressed = 0;
      }

      //if user loses, call on lose function
      else {
        lose();
        //reset button
        pressed = 0;
      }
    }

    //delay for stability
    delay(1);
  }

}

void win() {

  //blink 8 times
  for (int count = 0; count < 9; count++) {

    //use for loop to turn all LEDs on
    for (int x = 0; x < 8; x++) {
      digitalWrite(led[x], HIGH);
    }

    //hold for 200ms
    delay(200);

    //use for loop to turn all LEDs off
    for (int x = 0; x < 8; x++) {
      digitalWrite(led[x], LOW);
    }

    //hold for 500ms
    delay(200);
  }
}

void lose() {

  //turn on LEDs
  for (int x = 0; x < 8; x++) {
    digitalWrite(led[x], HIGH);
  }

  //hold for 400ms
  delay(400);

  //turn off LEDs one at a time
  for (int x = 7; x >= 0; x--) {
    digitalWrite(led[x], LOW);
    delay(400);
  }
}
